"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.initializeJavaScript = void 0;
const sources_1 = require("../sources");
const imports_1 = require("./imports");
const renames_1 = require("./renames");
const writeJavaScriptConfig_1 = require("./writeJavaScriptConfig");
const initializeJavaScript = ({ fileName, project }) => __awaiter(void 0, void 0, void 0, function* () {
    const sourceFiles = yield sources_1.initializeSources({ fromJavaScript: true });
    const renames = yield renames_1.initializeRenames();
    const imports = yield imports_1.initializeImports();
    yield writeJavaScriptConfig_1.writeJavaScriptConfig({ fileName, imports, project, sourceFiles, renames });
});
exports.initializeJavaScript = initializeJavaScript;
//# sourceMappingURL=index.js.map