"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.initializeRenames = exports.InitializationRenames = void 0;
const enquirer_1 = require("enquirer");
var InitializationRenames;
(function (InitializationRenames) {
    InitializationRenames["Auto"] = "Rename files containing JSX to .tsx and others to .ts";
    InitializationRenames["TS"] = "Rename all files to .ts";
    InitializationRenames["TSX"] = "Rename all files to .tsx";
})(InitializationRenames = exports.InitializationRenames || (exports.InitializationRenames = {}));
const initializeRenames = () => __awaiter(void 0, void 0, void 0, function* () {
    const { renames } = yield enquirer_1.prompt([
        {
            choices: [InitializationRenames.Auto, InitializationRenames.TS, InitializationRenames.TSX],
            initial: 0,
            message: "How would you like .js files to be renamed?",
            name: "renames",
            type: "select",
        },
    ]);
    return renames;
});
exports.initializeRenames = initializeRenames;
//# sourceMappingURL=renames.js.map