"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.initializeProject = void 0;
const enquirer_1 = require("enquirer");
const fs = __importStar(require("fs"));
const arrays_1 = require("../../shared/arrays");
const glob_1 = require("../../shared/glob");
const custom = "custom";
const defaultChoices = ["./tsconfig.json", "./src/tsconfig.json", custom];
const defaultSettings = {
    message: "Where is your tsconfig.json?",
    name: "project",
};
const initializeProject = () => __awaiter(void 0, void 0, void 0, function* () {
    const project = yield initializeBuiltInProject();
    return project === custom ? initializeCustomProject() : project;
});
exports.initializeProject = initializeProject;
const initializeBuiltInProject = () => __awaiter(void 0, void 0, void 0, function* () {
    var _a;
    const choices = [...arrays_1.uniquify("./tsconfig.json", ...(yield glob_1.globAllAsync(["./tsconfig*json", "./*/tsconfig*json"]))), custom];
    const { project } = yield enquirer_1.prompt([
        Object.assign(Object.assign({}, defaultSettings), { choices, initial: (_a = choices.findIndex((choice) => fs.existsSync(choice))) !== null && _a !== void 0 ? _a : defaultChoices.length - 1, type: "select" }),
    ]);
    return project;
});
const initializeCustomProject = () => __awaiter(void 0, void 0, void 0, function* () {
    const { project } = yield enquirer_1.prompt([
        Object.assign(Object.assign({}, defaultSettings), { initial: "./tsconfig.json", type: "text" }),
    ]);
    return project;
});
//# sourceMappingURL=index.js.map