"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.initializeImprovements = exports.InitializationImprovement = void 0;
const enquirer_1 = require("enquirer");
var InitializationImprovement;
(function (InitializationImprovement) {
    InitializationImprovement["MissingProperties"] = "Add missing property declarations to classes";
    InitializationImprovement["NoImplicitAny"] = "Enable the --noImplicitAny compiler flag";
    InitializationImprovement["NoImplicitThis"] = "Enable the --noImplicitThis compiler flag";
    InitializationImprovement["NoInferableTypes"] = "Remove type annotations that don't change the meaning of code";
    InitializationImprovement["StrictNullChecks"] = "Enable the --strictNullChecks compiler flag";
})(InitializationImprovement = exports.InitializationImprovement || (exports.InitializationImprovement = {}));
const initializeImprovements = () => __awaiter(void 0, void 0, void 0, function* () {
    const choices = [
        InitializationImprovement.MissingProperties,
        InitializationImprovement.NoImplicitAny,
        InitializationImprovement.NoImplicitThis,
        InitializationImprovement.NoInferableTypes,
        InitializationImprovement.StrictNullChecks,
    ];
    const { improvements } = yield enquirer_1.prompt([
        {
            choices,
            initial: 0,
            message: "Which improvements would you like to make?",
            name: "improvements",
            type: "multiselect",
        },
    ]);
    return improvements;
});
exports.initializeImprovements = initializeImprovements;
//# sourceMappingURL=improvements.js.map