"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.initializeTypeScript = void 0;
const sources_1 = require("../sources");
const improvements_1 = require("./improvements");
const initializeTests_1 = require("./initializeTests");
const writeMultiTypeScriptConfig_1 = require("./writeMultiTypeScriptConfig");
const writeSingleTypeScriptConfig_1 = require("./writeSingleTypeScriptConfig");
const initializeTypeScript = ({ fileName, project }) => __awaiter(void 0, void 0, void 0, function* () {
    const improvements = new Set(yield improvements_1.initializeImprovements());
    const sourceFiles = yield sources_1.initializeSources({ fromJavaScript: false });
    if (!improvements.has(improvements_1.InitializationImprovement.StrictNullChecks)) {
        yield writeSingleTypeScriptConfig_1.writeSingleTypeScriptConfig({ fileName, improvements, project, sourceFiles });
        return;
    }
    const testFiles = yield initializeTests_1.initializeTests();
    yield writeMultiTypeScriptConfig_1.writeMultiTypeScriptConfig({ fileName, improvements, project, sourceFiles, testFiles });
});
exports.initializeTypeScript = initializeTypeScript;
//# sourceMappingURL=index.js.map