"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.initializeTests = void 0;
const enquirer_1 = require("enquirer");
const other = "other";
const initializeTests = () => __awaiter(void 0, void 0, void 0, function* () {
    const builtIn = yield initializeBuiltInTests();
    return builtIn === other ? getCustomTests() : builtIn;
});
exports.initializeTests = initializeTests;
const initializeBuiltInTests = () => __awaiter(void 0, void 0, void 0, function* () {
    const choices = [
        "lib/**/__tests__/*.test.{ts,tsx}",
        "lib/**/*.test.{ts,tsx}",
        "src/**/__tests__/*.test.{ts,tsx}",
        "src/**/*.test.{ts,tsx}",
        "test/**/*.{ts,tsx}",
    ];
    const { testFiles } = yield enquirer_1.prompt([
        {
            choices,
            initial: choices.length - 1,
            message: "Which glob matches your test files?",
            name: "testFiles",
            type: "select",
        },
    ]);
    return testFiles;
});
const getCustomTests = () => __awaiter(void 0, void 0, void 0, function* () {
    const { testFiles } = yield enquirer_1.prompt([
        {
            initial: "test/**/*.{ts,tsx}",
            message: "Where are your test files?",
            name: "testFiles",
            type: "text",
        },
    ]);
    return testFiles;
});
//# sourceMappingURL=initializeTests.js.map