"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.writeMultiTypeScriptConfig = void 0;
const mz_1 = require("mz");
const improvements_1 = require("./improvements");
const writeMultiTypeScriptConfig = ({ fileName, improvements, project, sourceFiles, testFiles, }) => __awaiter(void 0, void 0, void 0, function* () {
    yield mz_1.fs.writeFile(fileName, JSON.stringify([
        {
            fixes: Object.assign(Object.assign({}, printImprovements(improvements)), { strictNonNullAssertions: true }),
            include: [testFiles],
            projectPath: project,
        },
        Object.assign(Object.assign({ exclude: [testFiles], fixes: printImprovements(improvements) }, (sourceFiles && { include: [sourceFiles] })), { projectPath: project }),
        {
            fixes: printImprovements(improvements),
            include: [testFiles, sourceFiles],
            projectPath: project,
        },
    ], undefined, 4));
});
exports.writeMultiTypeScriptConfig = writeMultiTypeScriptConfig;
const printImprovements = (improvements) => {
    return Object.assign(Object.assign(Object.assign({ incompleteTypes: true }, (improvements.has(improvements_1.InitializationImprovement.NoImplicitAny) && { noImplicitAny: true })), (improvements.has(improvements_1.InitializationImprovement.NoInferableTypes) && { inferableTypes: true })), (improvements.has(improvements_1.InitializationImprovement.NoImplicitThis) && { noImplicitThis: true }));
};
//# sourceMappingURL=writeMultiTypeScriptConfig.js.map