"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.writeSingleTypeScriptConfig = void 0;
const mz_1 = require("mz");
const improvements_1 = require("./improvements");
const writeSingleTypeScriptConfig = ({ fileName, project, sourceFiles, improvements }) => __awaiter(void 0, void 0, void 0, function* () {
    yield mz_1.fs.writeFile(fileName, JSON.stringify(Object.assign(Object.assign({ fixes: printImprovements(improvements) }, (sourceFiles && { include: [sourceFiles] })), { projectPath: project }), undefined, 4));
});
exports.writeSingleTypeScriptConfig = writeSingleTypeScriptConfig;
const printImprovements = (improvements) => {
    return Object.assign(Object.assign({ incompleteTypes: true }, (improvements.has(improvements_1.InitializationImprovement.NoImplicitAny) && { noImplicitAny: true })), (improvements.has(improvements_1.InitializationImprovement.NoImplicitThis) && { noImplicitThis: true }));
};
//# sourceMappingURL=writeSingleTypeScriptConfig.js.map