"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.initializeSources = void 0;
const enquirer_1 = require("enquirer");
const everything = "everything";
const other = "other";
const initializeSources = (settings) => __awaiter(void 0, void 0, void 0, function* () {
    const completion = settings.fromJavaScript ? "/**/*.{js,jsx}" : "/**/*.{ts,tsx}";
    const builtIn = yield initializeBuiltInSources(completion);
    if (builtIn === other) {
        return yield getCustomSources(completion);
    }
    if (builtIn === everything) {
        return undefined;
    }
    return builtIn;
});
exports.initializeSources = initializeSources;
const initializeBuiltInSources = (completion) => __awaiter(void 0, void 0, void 0, function* () {
    // https://github.com/enquirer/enquirer/issues/202
    const choices = [
        {
            message: "everything in my tsconfig.json",
            name: everything,
        },
        `lib${completion}`,
        `src${completion}`,
        other,
    ];
    const { sourceFiles } = yield enquirer_1.prompt([
        {
            choices,
            initial: choices.length - 1,
            message: "Which glob matches files you'd like to convert?",
            name: "sourceFiles",
            type: "select",
        },
    ]);
    return sourceFiles;
});
const getCustomSources = (completion) => __awaiter(void 0, void 0, void 0, function* () {
    const { sourceFiles } = yield enquirer_1.prompt([
        {
            initial: `src${completion}`,
            message: "Which files would you like to convert?",
            name: "sourceFiles",
            type: "text",
        },
    ]);
    return sourceFiles;
});
//# sourceMappingURL=index.js.map