"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.joinIntoType = void 0;
const arrays_1 = require("../../shared/arrays");
const aliases_1 = require("./aliases");
const joinIntoType = (flags, types, request) => {
    const alias = aliases_1.getApplicableTypeAliases(request);
    return arrays_1.uniquify(...Array.from(types)
        .map((type) => request.services.printers.type(type))
        .map((type) => (type.includes("=>") ? `(${type})` : type)), ...Array.from(flags)
        .map((flag) => alias.get(flag))
        .filter(arrays_1.isNotUndefined)).join(" | ");
};
exports.joinIntoType = joinIntoType;
//# sourceMappingURL=joinIntoType.js.map