"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.getMissingPropertyMutations = void 0;
const ts = __importStar(require("typescript"));
const creation_1 = require("./creation");
/**
 * Error code for the TypeScript language service to add a missing property.
 */
const fixMissingPropertyErrorCode = 2339;
const getMissingPropertyMutations = (request, node) => {
    // Skip nodes that aren't setting a member of a `this` node
    if (!nodeIsSettingThisMember(node)) {
        return undefined;
    }
    const codeFixes = getMissingPropertyCodeFixes(node, request);
    if (codeFixes.length === 0) {
        return undefined;
    }
    return creation_1.createCodeFixCreationMutation(request, codeFixes);
};
exports.getMissingPropertyMutations = getMissingPropertyMutations;
/**
 * @returns Whether a property access is setting a 'this' member.
 */
const nodeIsSettingThisMember = (node) => ts.isBinaryExpression(node.parent) &&
    node.parent.operatorToken.kind === ts.SyntaxKind.EqualsToken &&
    node.expression.kind === ts.SyntaxKind.ThisKeyword;
/**
 * Uses a requesting language service to get missing property code fixes for a type of node.
 */
const getMissingPropertyCodeFixes = (node, request) => request.services.languageService.getCodeFixesAtPosition(request.sourceFile.fileName, node.name.getStart(request.sourceFile), node.end, [fixMissingPropertyErrorCode], {
    insertSpaceBeforeAndAfterBinaryOperators: true,
}, {});
//# sourceMappingURL=addMissingProperty.js.map