"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.joinIntoGenericType = void 0;
const ts = __importStar(require("typescript"));
const types_1 = require("../shared/types");
const arrays_1 = require("./arrays");
/**
 * Creates a type like "string[]" or "Map<boolean | number>" from a container and type arguments.
 */
const joinIntoGenericType = (request, containerType, allTypeArgumentTypes) => {
    const containerTypeName = request.services.printers
        .type(containerType, undefined, ts.TypeFormatFlags.WriteArrayAsGenericType)
        // Names with parameters like Array<T> and Map<K, V> should ignore those parameters
        .split("<")[0];
    // By now we're assuming the generic types can all be named
    // eslint-disable-next-line @typescript-eslint/no-non-null-assertion
    const genericTypeNames = allTypeArgumentTypes.map((genericTypes) => request.services.printers.type(genericTypes));
    if (containerTypeName.split("<")[0] === "Array" && types_1.isTypeBuiltIn(containerType)) {
        return arrays_1.constructArrayShorthand(genericTypeNames);
    }
    return `${containerTypeName}<${genericTypeNames.join(", ")}>`;
};
exports.joinIntoGenericType = joinIntoGenericType;
//# sourceMappingURL=generics.js.map