"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.getFriendlyTypeParameterDeclarationName = exports.getPerceivedNameOfClass = exports.isUpperCaseLetter = void 0;
const ts = __importStar(require("typescript"));
const isUpperCaseLetter = (letter) => {
    return letter !== letter.toLowerCase();
};
exports.isUpperCaseLetter = isUpperCaseLetter;
const getPerceivedNameOfClass = (request, node) => {
    // Clases with their own names are the most common and mostly friendly case
    if (node.name !== undefined) {
        return node.name.text;
    }
    // If the class is directly within a named variable, use that name
    const { parent } = node;
    if (ts.isVariableDeclaration(parent) && ts.isIdentifier(parent.name)) {
        return parent.name.text;
    }
    // We could probably do fancier things at this point but why bother...
    return request.nameGenerator.generateName("Class");
};
exports.getPerceivedNameOfClass = getPerceivedNameOfClass;
const getFriendlyTypeParameterDeclarationName = (baseTypeParameters, typeParameter) => {
    const typeNameRaw = typeParameter.name.text;
    const typeNameFriendly = typeNameRaw.length > 1 && typeNameRaw.startsWith("T") && exports.isUpperCaseLetter(typeNameRaw[1]) ? typeNameRaw.slice(1) : typeNameRaw;
    // If any sibling parameter actually happens to match the friendly name, use the raw instead
    for (const siblingParameter of baseTypeParameters) {
        if (siblingParameter !== typeParameter && siblingParameter.name.text === typeNameFriendly) {
            return typeNameRaw;
        }
    }
    return typeNameFriendly;
};
exports.getFriendlyTypeParameterDeclarationName = getFriendlyTypeParameterDeclarationName;
//# sourceMappingURL=naming.js.map