"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.createRequireMutation = void 0;
const createRequireMutation = (request, node) => {
    const newLocalFilePath = node.arguments[0].text.replace(/.js$/i, ".ts").replace(/.jsx$/i, ".tsx");
    const newLocalImportPath = newLocalFilePath.replace(/.tsx?$/i, "");
    return {
        insertion: `(${node.getText(request.sourceFile)} as typeof import("${newLocalImportPath}"))`,
        range: {
            begin: node.getStart(request.sourceFile),
            end: node.end,
        },
        type: "text-swap",
    };
};
exports.createRequireMutation = createRequireMutation;
//# sourceMappingURL=createRequireMutation.js.map