"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.createNonNullAssertion = void 0;
const ts = __importStar(require("typescript"));
// The following node types need to be wrapped in parenthesis to stop the ! from being applied to the wrong (last) element:
// As expressions: foo as Bar
// Binary expressions: foo && bar
// Conditional expressions: foo ? bar : baz
// Void expressions: void 0
const wrappedKinds = new Set([
    ts.SyntaxKind.AsExpression,
    ts.SyntaxKind.AwaitExpression,
    ts.SyntaxKind.BinaryExpression,
    ts.SyntaxKind.ConditionalExpression,
    ts.SyntaxKind.VoidExpression,
]);
const createNonNullAssertion = (request, node) => {
    // For property assignments (`key: value`), create a non-null assertion only for `value`.
    if (ts.isPropertyAssignment(node)) {
        node = node.initializer;
    }
    // If the node must be wrapped in parenthesis, replace all of it
    if (wrappedKinds.has(node.kind)) {
        return {
            insertion: `(${node.getText(request.sourceFile)})!`,
            range: {
                begin: node.getStart(request.sourceFile),
                end: node.end,
            },
            type: "text-swap",
        };
    }
    // Shorthand assignments (`{ value }`) must be converted to non-shorthand (`{ value: value ! }`)
    const insertion = ts.isShorthandPropertyAssignment(node) ? `: ${node.getText(request.sourceFile)}!` : "!";
    return {
        insertion,
        range: {
            begin: node.end,
        },
        type: "text-insert",
    };
};
exports.createNonNullAssertion = createNonNullAssertion;
//# sourceMappingURL=createNonNullAssertion.js.map