"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.fixImportExtensions = void 0;
const glob_1 = __importDefault(require("glob"));
const path = __importStar(require("path"));
const ts = __importStar(require("typescript"));
const types_1 = require("../../../shared/types");
const collectMutationsFromNodes_1 = require("../../collectMutationsFromNodes");
const fixImportExtensions = (request) => request.options.fixes.importExtensions
    ? collectMutationsFromNodes_1.collectMutationsFromNodes(request, isExtensionlessExportOrImport, visitExportOrImportDeclaration)
    : undefined;
exports.fixImportExtensions = fixImportExtensions;
const isExtensionlessExportOrImport = (node) => {
    return ((ts.isImportDeclaration(node) || ts.isExportDeclaration(node)) &&
        node.moduleSpecifier !== undefined &&
        ts.isStringLiteral(node.moduleSpecifier) &&
        !path.basename(node.moduleSpecifier.text).includes("."));
};
const visitExportOrImportDeclaration = (node, request) => {
    // If the type of the import is already known, we don't need to fix it
    if (types_1.getTypeAtLocationIfNotError(request, node.moduleSpecifier) !== undefined) {
        return undefined;
    }
    // Try each path that the import could resolve to
    const basePath = path.join(path.dirname(request.sourceFile.fileName), node.moduleSpecifier.text);
    for (const filePath of [basePath, path.join(basePath, "index")]) {
        // If no files exist under that path, ignore this possibility
        const possibilities = glob_1.default.sync(filePath + ".*");
        if (possibilities.length === 0) {
            continue;
        }
        // Figure out which extension might be relevant (i.e. anything but build artifacts)
        const mostLikely = possibilities.find((possibility) => !/\.(((j|t)sx?)|map)$/.test(possibility));
        if (mostLikely === undefined) {
            continue;
        }
        // Add the file's full extension to the original module specifier
        return {
            insertion: "." + path.basename(mostLikely).split(".").slice(1).join("."),
            range: {
                begin: node.moduleSpecifier.end - 1,
            },
            type: "text-insert",
        };
    }
    return undefined;
};
//# sourceMappingURL=index.js.map