"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.addMissingTemplateTypes = exports.addNewTypeNodes = void 0;
const newlines_1 = require("../../../../shared/printing/newlines");
const addNewTypeNodes = (request, node, createdTypes) => {
    const endline = newlines_1.printNewLine(request.options.compilerOptions);
    return {
        insertion: `${endline}${createdTypes.join(endline)}`,
        range: {
            begin: node.pos,
        },
        type: "text-insert",
    };
};
exports.addNewTypeNodes = addNewTypeNodes;
const addMissingTemplateTypes = (extension, templateTypeNames) => {
    if (extension.typeArguments === undefined) {
        return {
            insertion: `<${templateTypeNames.join(", ")}>`,
            range: {
                begin: extension.end,
            },
            type: "text-insert",
        };
    }
    const lastExistingTypeArgument = extension.typeArguments[extension.typeArguments.length - 1];
    return {
        insertion: `, ${templateTypeNames.slice(extension.typeArguments.length).join(", ")}`,
        range: {
            begin: lastExistingTypeArgument.end,
        },
        type: "text-insert",
    };
};
exports.addMissingTemplateTypes = addMissingTemplateTypes;
//# sourceMappingURL=additions.js.map