"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.fixIncompleteImplicitClassGenerics = void 0;
const automutate_1 = require("automutate");
const ts = __importStar(require("typescript"));
const arrays_1 = require("../../../../../shared/arrays");
const nodeExtensions_1 = require("../../../../../shared/nodeExtensions");
const collectMutationsFromNodes_1 = require("../../../../collectMutationsFromNodes");
const additions_1 = require("../additions");
const templateCollecting_1 = require("../templateCollecting");
const templateMutating_1 = require("../templateMutating");
const fixIncompleteImplicitClassGenerics = (request) => collectMutationsFromNodes_1.collectMutationsFromNodes(request, ts.isClassLike, visitClassLike);
exports.fixIncompleteImplicitClassGenerics = fixIncompleteImplicitClassGenerics;
const visitClassLike = (node, request) => {
    // We'll want a class node that extends some base class
    const extension = nodeExtensions_1.getClassExtendsExpression(node);
    if (extension === undefined) {
        return undefined;
    }
    // If that base class doesn't include type parameters, there's nothing to fill out
    const baseClass = nodeExtensions_1.getBaseClassDeclaration(request, extension);
    if (baseClass === undefined || baseClass.typeParameters === undefined) {
        return undefined;
    }
    // If that class declares any templated types, check the node's types assigned as them
    const missingTemplateTypes = templateCollecting_1.findMissingTemplateTypes(request, node, baseClass);
    // We can skip performing any mutation if none of the parameter types had missing types
    if (missingTemplateTypes.length === 0 || !missingTemplateTypes.some(arrays_1.isNotUndefined)) {
        return undefined;
    }
    // Collect type names to fill in and their corresponding new type declarations
    const { createdTypes, templateTypeNames } = templateMutating_1.fillInMissingTemplateTypes(request, node, baseClass.typeParameters, missingTemplateTypes);
    // Print the new types above the class and fill in the new template types
    return automutate_1.combineMutations(additions_1.addNewTypeNodes(request, node, createdTypes), additions_1.addMissingTemplateTypes(extension, templateTypeNames));
};
//# sourceMappingURL=index.js.map