"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.fixIncompleteInterfaceOrTypeLiteralGenerics = void 0;
const ts = __importStar(require("typescript"));
const assignments_1 = require("../../../../mutations/assignments");
const expansionMutations_1 = require("../../../../mutations/expansions/expansionMutations");
const types_1 = require("../../../../shared/types");
const collectMutationsFromNodes_1 = require("../../../collectMutationsFromNodes");
const collectGenericNodeReferences_1 = require("./collectGenericNodeReferences");
const expandValuesAssignedToReferenceNodes_1 = require("./expandValuesAssignedToReferenceNodes");
const fixIncompleteInterfaceOrTypeLiteralGenerics = (request) => collectMutationsFromNodes_1.collectMutationsFromNodes(request, isInterfaceOrTypeLiteral, visitInterfaceOrTypeLiteral);
exports.fixIncompleteInterfaceOrTypeLiteralGenerics = fixIncompleteInterfaceOrTypeLiteralGenerics;
const isInterfaceOrTypeLiteral = (node) => ts.isInterfaceDeclaration(node) || ts.isTypeLiteralNode(node);
const visitInterfaceOrTypeLiteral = (node, request) => {
    // Find all nodes that seem like they could possibly reference the generic
    const genericReferenceNodes = collectGenericNodeReferences_1.collectGenericNodeReferences(request, node);
    if (genericReferenceNodes === undefined) {
        return undefined;
    }
    // Given all those generic references, find all the types being assigned to those nodes
    const originalType = types_1.getTypeAtLocationIfNotError(request, node);
    if (originalType === undefined) {
        return undefined;
    }
    const valuesAssignedToReferenceNodes = expandValuesAssignedToReferenceNodes_1.expandValuesAssignedToReferenceNodes(request, originalType, genericReferenceNodes);
    if (valuesAssignedToReferenceNodes.length === 0) {
        return undefined;
    }
    // Join those types into a mapping that keys them by property name
    // That mapping is directly translatable into a mutation to add those properties
    return expansionMutations_1.createTypeExpansionMutation(request, node, [assignments_1.joinAssignedTypesByName(request, valuesAssignedToReferenceNodes)]);
};
//# sourceMappingURL=index.js.map