"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.fixReactPropFunctionsFromCalls = void 0;
const collectMutationsFromNodes_1 = require("../../../../collectMutationsFromNodes");
const isReactComponentNode_1 = require("../reactFiltering/isReactComponentNode");
const getComponentPropsNode_1 = require("../getComponentPropsNode");
const collectAllFunctionCallTypes_1 = require("./collectAllFunctionCallTypes");
const createFunctionCallTypesMutation_1 = require("./createFunctionCallTypesMutation");
/**
 * Expands a component's props declared as Function to be more specific types.
 */
const fixReactPropFunctionsFromCalls = (request) => {
    return collectMutationsFromNodes_1.collectMutationsFromNodes(request, isReactComponentNode_1.isReactComponentNode, visitReactComponentNode);
};
exports.fixReactPropFunctionsFromCalls = fixReactPropFunctionsFromCalls;
const visitReactComponentNode = (node, request) => {
    // Grab the node used to declare the node's props type, if it exists
    const propsNode = getComponentPropsNode_1.getComponentPropsNode(request, node);
    if (propsNode === undefined) {
        return undefined;
    }
    // Find all Function prop calls used internally within the node
    const allFunctionCallTypes = collectAllFunctionCallTypes_1.collectAllFunctionCallTypes(request, propsNode);
    if (allFunctionCallTypes === undefined) {
        return undefined;
    }
    return createFunctionCallTypesMutation_1.createFunctionCallTypesMutation(request, allFunctionCallTypes);
};
//# sourceMappingURL=index.js.map