"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.createInterfaceUsageMutation = void 0;
const ts = __importStar(require("typescript"));
const nodes_1 = require("../../../../../../shared/nodes");
const createInterfaceUsageMutation = (node, interfaceName) => {
    return ts.isClassLike(node)
        ? createClassInterfaceUsageMutation(node, interfaceName)
        : createFunctionLikeInterfaceUsageMutation(node, interfaceName);
};
exports.createInterfaceUsageMutation = createInterfaceUsageMutation;
const createClassInterfaceUsageMutation = (node, interfaceName) => {
    const extension = nodes_1.getClassExtendsType(node);
    if (extension === undefined) {
        return undefined;
    }
    return {
        insertion: `<${interfaceName}>`,
        range: {
            begin: extension.end,
        },
        type: "text-insert",
    };
};
const createFunctionLikeInterfaceUsageMutation = (node, interfaceName) => {
    const propsArgument = node.parameters[0];
    return {
        insertion: `: ${interfaceName}`,
        range: {
            begin: propsArgument.end,
        },
        type: "text-insert",
    };
};
//# sourceMappingURL=createInterfaceUsageMutation.js.map