"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.getApparentNameOfComponent = exports.createInterfaceFromPropTypes = void 0;
const tsutils = __importStar(require("tsutils"));
const ts = __importStar(require("typescript"));
const fileNames_1 = require("../../../../../../shared/fileNames");
const propTypesProperties_1 = require("./propTypesProperties");
const createInterfaceFromPropTypes = (request, node, propTypes) => {
    const members = [];
    for (const rawProperty of propTypes.properties) {
        const member = propTypesProperties_1.createPropTypesProperty(request, rawProperty);
        if (member !== undefined) {
            members.push(member);
        }
    }
    const interfaceName = `${exports.getApparentNameOfComponent(request, node)}Props`;
    const interfaceNode = ts.factory.createInterfaceDeclaration(undefined /* decorators */, undefined /* modifiers */, interfaceName, undefined /* typeParameters */, undefined /* heritageClauses */, members);
    return { interfaceName, interfaceNode };
};
exports.createInterfaceFromPropTypes = createInterfaceFromPropTypes;
const getApparentNameOfComponent = (request, node) => {
    // If the node itself has a name, great!
    if (node.name !== undefined) {
        return node.name.text;
    }
    // If the node is the default export of its file, use the file's name
    if (tsutils.hasModifier(node.modifiers, ts.SyntaxKind.DefaultKeyword)) {
        return fileNames_1.getFriendlyFileName(request.sourceFile.fileName);
    }
    return "AnonymousClass";
};
exports.getApparentNameOfComponent = getApparentNameOfComponent;
//# sourceMappingURL=createInterfaceFromPropTypes.js.map