"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.createPropTypesProperty = void 0;
const ts = __importStar(require("typescript"));
const enums_1 = require("../../../../../../options/enums");
const propTypesExtraction_1 = require("./propTypesExtraction");
const propTypesTransforms_1 = require("./propTypesTransforms");
/**
 * Creates a type signature node for a raw PropTypes object literal property.
 */
const createPropTypesProperty = (request, rawProperty) => {
    if (!ts.isPropertyAssignment(rawProperty) || !ts.isIdentifier(rawProperty.name)) {
        return undefined;
    }
    const propTypesMembers = propTypesExtraction_1.getPropTypesMember(rawProperty.initializer);
    if (propTypesMembers === undefined) {
        return undefined;
    }
    const memberTypeNode = propTypesTransforms_1.createPropTypesTransform(request, propTypesMembers);
    if (memberTypeNode === undefined) {
        return undefined;
    }
    return ts.factory.createPropertySignature(undefined /* modifiers */, ts.factory.createIdentifier(rawProperty.name.text), getQuestionToken(!!propTypesMembers.isRequired, request.options.hints.react.propTypesOptionality), memberTypeNode);
};
exports.createPropTypesProperty = createPropTypesProperty;
const getQuestionToken = (isRequired, optionality) => {
    return optionality === enums_1.ReactPropTypesOptionality.AlwaysOptional || (!isRequired && optionality === enums_1.ReactPropTypesOptionality.AsWritten)
        ? ts.factory.createToken(ts.SyntaxKind.QuestionToken)
        : undefined;
};
//# sourceMappingURL=propTypesProperties.js.map