"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.isReactComponentNode = void 0;
const ts = __importStar(require("typescript"));
const nodes_1 = require("../../../../../shared/nodes");
/**
 * @returns Whether the node is able to be a React component node.
 */
const isReactComponentNode = (node) => {
    // Functions can generally be React components if they have 0 or 1 parameters
    if (ts.isArrowFunction(node) || ts.isFunctionDeclaration(node) || ts.isFunctionExpression(node)) {
        return node.parameters.length <= 1;
    }
    // Otherwise, we only look at class declarations
    if (!ts.isClassDeclaration(node)) {
        return false;
    }
    const extendsType = nodes_1.getClassExtendsType(node);
    return extendsType !== undefined && extensionExpressionIsReactComponent(extendsType);
};
exports.isReactComponentNode = isReactComponentNode;
const extensionExpressionIsReactComponent = (node) => {
    // Todo: actually check the type for this
    // See https://github.com/JoshuaKGoldberg/TypeStat/issues/135
    return node.getText().includes("Component");
};
//# sourceMappingURL=isReactComponentNode.js.map