"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.fixIncompleteReturnTypes = void 0;
const tsutils = __importStar(require("tsutils"));
const creators_1 = require("../../../../mutations/creators");
const arrays_1 = require("../../../../shared/arrays");
const nodeTypes_1 = require("../../../../shared/nodeTypes");
const types_1 = require("../../../../shared/types");
const collectMutationsFromNodes_1 = require("../../../collectMutationsFromNodes");
const collectReturningNodeExpressions_1 = require("../../fixStrictNonNullAssertions/fixStrictNonNullAssertionReturnTypes/collectReturningNodeExpressions");
const fixIncompleteReturnTypes = (request) => collectMutationsFromNodes_1.collectMutationsFromNodes(request, isNodeVisitableFunctionLikeDeclaration, visitFunctionWithBody);
exports.fixIncompleteReturnTypes = fixIncompleteReturnTypes;
const isNodeVisitableFunctionLikeDeclaration = (node) => tsutils.isFunctionWithBody(node) &&
    // If the node has an implicit return type, we don't need to change anything
    nodeTypes_1.isNodeWithType(node);
const visitFunctionWithBody = (node, request) => {
    // Collect the type initially declared as returned
    const declaredType = types_1.getTypeAtLocationIfNotError(request, node.type);
    if (declaredType === undefined) {
        return undefined;
    }
    // Collect types of nodes returned by the function
    const returnedTypes = collectReturningNodeExpressions_1.collectReturningNodeExpressions(node)
        .map((node) => types_1.getTypeAtLocationIfNotError(request, node))
        .filter(arrays_1.isNotUndefined);
    // Add later-returned types to the node's type declaration if necessary
    return creators_1.createTypeAdditionMutation(request, node, declaredType, returnedTypes);
};
//# sourceMappingURL=index.js.map