"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.fixIncompleteTypes = void 0;
const runtime_1 = require("../../../shared/runtime");
const fixIncompleteImplicitGenerics_1 = require("./fixIncompleteImplicitGenerics");
const fixIncompleteInterfaceOrTypeLiteralGenerics_1 = require("./fixIncompleteInterfaceOrTypeLiteralGenerics");
const fixIncompleteParameterTypes_1 = require("./fixIncompleteParameterTypes");
const fixIncompletePropertyDeclarationTypes_1 = require("./fixIncompletePropertyDeclarationTypes");
const fixIncompleteReactTypes_1 = require("./fixIncompleteReactTypes");
const fixIncompleteReturnTypes_1 = require("./fixIncompleteReturnTypes");
const fixIncompleteVariableTypes_1 = require("./fixIncompleteVariableTypes");
const fixIncompleteTypes = (request) => request.options.fixes.incompleteTypes
    ? runtime_1.findFirstMutations(request, [
        ["fixIncompleteImplicitGenerics", fixIncompleteImplicitGenerics_1.fixIncompleteImplicitGenerics],
        ["fixIncompleteInterfaceOrTypeLiteralGenerics", fixIncompleteInterfaceOrTypeLiteralGenerics_1.fixIncompleteInterfaceOrTypeLiteralGenerics],
        ["fixIncompleteParameterTypes", fixIncompleteParameterTypes_1.fixIncompleteParameterTypes],
        ["fixIncompletePropertyDeclarationTypes", fixIncompletePropertyDeclarationTypes_1.fixIncompletePropertyDeclarationTypes],
        ["fixIncompleteReactTypes", fixIncompleteReactTypes_1.fixIncompleteReactTypes],
        ["fixIncompleteReturnTypes", fixIncompleteReturnTypes_1.fixIncompleteReturnTypes],
        ["fixIncompleteVariableTypes", fixIncompleteVariableTypes_1.fixIncompleteVariableTypes],
    ])
    : undefined;
exports.fixIncompleteTypes = fixIncompleteTypes;
//# sourceMappingURL=index.js.map