"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.fixMissingPropertyAccesses = void 0;
const ts = __importStar(require("typescript"));
const addMissingProperty_1 = require("../../../../mutations/codeFixes/addMissingProperty");
const types_1 = require("../../../../shared/types");
const collectMutationsFromNodes_1 = require("../../../collectMutationsFromNodes");
const fixMissingPropertyAccesses = (request) => {
    // If an undeclared property is referenced multiple times, TypeScript will suggest adding it in each time
    // We therefore only suggest each property name once per wave
    // In theory, we could also respect each node name per class, but that's hard, and it's rare to have many classes per file
    const suggestedMissingProperties = new Set();
    const visitPropertyAccessExpression = (node) => {
        // If the access should create a missing property, go for that
        const missingPropertyFix = addMissingProperty_1.getMissingPropertyMutations(request, node);
        if (missingPropertyFix === undefined) {
            return undefined;
        }
        // Don't suggest this missing property if a node of this name was already added
        if (suggestedMissingProperties.has(node.name.text)) {
            return undefined;
        }
        // Additionally, for some reason, the language service seems suggest the same fixes repeatedly sometimes...
        // To get around this, we ignore any fixes for nodes that already exist on the parent class
        // https://github.com/JoshuaKGoldberg/TypeStat/issues/756
        const assigneeClassType = types_1.getTypeAtLocationIfNotError(request, node.expression);
        if ((assigneeClassType === null || assigneeClassType === void 0 ? void 0 : assigneeClassType.getProperty(node.name.text)) !== undefined) {
            return undefined;
        }
        suggestedMissingProperties.add(node.name.text);
        return missingPropertyFix;
    };
    return collectMutationsFromNodes_1.collectMutationsFromNodes(request, ts.isPropertyAccessExpression, visitPropertyAccessExpression);
};
exports.fixMissingPropertyAccesses = fixMissingPropertyAccesses;
//# sourceMappingURL=index.js.map