"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.fixNoImplicitAnyVariableDeclarations = void 0;
const ts = __importStar(require("typescript"));
const noImplicitAny_1 = require("../../../../mutations/codeFixes/noImplicitAny");
const collectMutationsFromNodes_1 = require("../../../collectMutationsFromNodes");
const fixNoImplicitAnyVariableDeclarations = (request) => {
    // This mutator fixes only for --noImplicitAny
    if (!request.options.fixes.noImplicitAny) {
        return [];
    }
    return collectMutationsFromNodes_1.collectMutationsFromNodes(request, isNodeVisitableVariableDeclaration, visitVariableDeclaration);
};
exports.fixNoImplicitAnyVariableDeclarations = fixNoImplicitAnyVariableDeclarations;
const isNodeVisitableVariableDeclaration = (node) => ts.isVariableDeclaration(node) &&
    // Binding patterns are all implicitly typed, so ignore them
    !(ts.isArrayBindingPattern(node.name) || ts.isObjectBindingPattern(node.name)) &&
    // For-in and for-of loop varibles cannot have types, so don't bother trying to add them
    !ts.isForInStatement(node.parent.parent) &&
    !ts.isForOfStatement(node.parent.parent);
const visitVariableDeclaration = (node, request) => {
    // If the variable violates --noImplicitAny (has no type or initializer), this can only be a --noImplicitAny fix
    if (noImplicitAny_1.canNodeBeFixedForNoImplicitAny(node)) {
        return noImplicitAny_1.getNoImplicitAnyMutations(node, request);
    }
    return undefined;
};
//# sourceMappingURL=index.js.map