"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.fixNoInferableTypesParameters = void 0;
const ts = __importStar(require("typescript"));
const removals_1 = require("../../../../mutations/removals");
const comparisons_1 = require("../../../../shared/comparisons");
const nodeTypes_1 = require("../../../../shared/nodeTypes");
const collectMutationsFromNodes_1 = require("../../../collectMutationsFromNodes");
const fixNoInferableTypesParameters = (request) => collectMutationsFromNodes_1.collectMutationsFromNodes(request, isInferableTypeCapableParameter, getNoInferableTypeParameterMutation);
exports.fixNoInferableTypesParameters = fixNoInferableTypesParameters;
const isInferableTypeCapableParameter = (node) => ts.isParameter(node) && nodeTypes_1.isNodeWithType(node) && node.modifiers === undefined;
const getNoInferableTypeParameterMutation = (node, request) => {
    if (!parameterTypeIsInferable(request, node)) {
        return undefined;
    }
    return removals_1.createTypeRemovalMutation(request, node);
};
const parameterTypeIsInferable = (request, node) => {
    // If the parameter has an initializer (default value), that might invalidate its type
    if (node.initializer) {
        if (comparisons_1.declaredInitializedTypeNodeIsRedundant(request, node.type, node.initializer)) {
            return true;
        }
    }
    // Eventually, it'd be nice to check for parameters whose values are inferable from
    // their parent function's declarations, e.g.
    // ```ts
    // type TakesString = (input: string) => void;
    // const takesString: TakesString = (input: string) => {};
    // ```
    // See https://github.com/microsoft/TypeScript/issues/35691
    return false;
};
//# sourceMappingURL=index.js.map