"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.fixNoInferableTypesVariableDeclarations = void 0;
const tsutils = __importStar(require("tsutils"));
const ts = __importStar(require("typescript"));
const removals_1 = require("../../../../mutations/removals");
const comparisons_1 = require("../../../../shared/comparisons");
const nodeTypes_1 = require("../../../../shared/nodeTypes");
const collectMutationsFromNodes_1 = require("../../../collectMutationsFromNodes");
const fixNoInferableTypesVariableDeclarations = (request) => collectMutationsFromNodes_1.collectMutationsFromNodes(request, isInferableTypeCapableVariableDeclaration, getNoInferableTypeVariableDeclarationMutation);
exports.fixNoInferableTypesVariableDeclarations = fixNoInferableTypesVariableDeclarations;
const isInferableTypeCapableVariableDeclaration = (node) => ts.isVariableDeclaration(node) && nodeTypes_1.isNodeWithType(node) && node.initializer !== undefined && ts.isVariableDeclarationList(node.parent);
const getNoInferableTypeVariableDeclarationMutation = (node, request) => {
    if (
    // `const` variables should always have their declarations removed
    tsutils.isNodeFlagSet(node.parent, ts.NodeFlags.Const) ||
        // `let` variables should have only uninformative declarations removed
        comparisons_1.declaredInitializedTypeNodeIsRedundant(request, node.type, node.initializer)) {
        return removals_1.createTypeRemovalMutation(request, node);
    }
    return undefined;
};
//# sourceMappingURL=index.js.map