"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.fixStrictNonNullAssertionBinaryExpressions = void 0;
const tsutils_1 = require("tsutils");
const ts = __importStar(require("typescript"));
const flags_1 = require("../../../../mutations/collecting/flags");
const createNonNullAssertion_1 = require("../../../../mutations/typeMutating/createNonNullAssertion");
const nodes_1 = require("../../../../shared/nodes");
const types_1 = require("../../../../shared/types");
const collectMutationsFromNodes_1 = require("../../../collectMutationsFromNodes");
const fixStrictNonNullAssertionBinaryExpressions = (request) => {
    return collectMutationsFromNodes_1.collectMutationsFromNodes(request, nodes_1.isNodeAssigningBinaryExpression, visitBinaryExpression);
};
exports.fixStrictNonNullAssertionBinaryExpressions = fixStrictNonNullAssertionBinaryExpressions;
const visitBinaryExpression = (node, request) => {
    // Grab the types of the declared and assigned nodes
    const assignedType = types_1.getTypeAtLocationIfNotError(request, node.right);
    if (assignedType === undefined) {
        return undefined;
    }
    const declaredType = types_1.getTypeAtLocationIfNotError(request, node.left);
    if (declaredType === undefined || tsutils_1.isTypeFlagSet(declaredType, ts.TypeFlags.Any)) {
        return undefined;
    }
    // We only care if the assigned type contains a strict flag the declared type doesn't
    if ((flags_1.isTypeFlagSetRecursively(declaredType, ts.TypeFlags.Null) || !flags_1.isTypeFlagSetRecursively(assignedType, ts.TypeFlags.Null)) &&
        (flags_1.isTypeFlagSetRecursively(declaredType, ts.TypeFlags.Undefined) || !flags_1.isTypeFlagSetRecursively(assignedType, ts.TypeFlags.Undefined))) {
        return undefined;
    }
    return createNonNullAssertion_1.createNonNullAssertion(request, node.right);
};
//# sourceMappingURL=index.js.map