"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.fixStrictNonNullAssertionObjectLiterals = void 0;
const automutate_1 = require("automutate");
const ts = __importStar(require("typescript"));
const createNonNullAssertion_1 = require("../../../../mutations/typeMutating/createNonNullAssertion");
const collectMutationsFromNodes_1 = require("../../../collectMutationsFromNodes");
const assignments_1 = require("../../../../shared/assignments");
const names_1 = require("../../../../shared/names");
const nodeTypes_1 = require("../../../../shared/nodeTypes");
const types_1 = require("../../../../shared/types");
const fixStrictNonNullAssertionObjectLiterals = (request) => {
    const visitObjectLiteralExpression = (node) => {
        return getStrictPropertyFix(request, node);
    };
    return collectMutationsFromNodes_1.collectMutationsFromNodes(request, ts.isObjectLiteralExpression, visitObjectLiteralExpression);
};
exports.fixStrictNonNullAssertionObjectLiterals = fixStrictNonNullAssertionObjectLiterals;
const getStrictPropertyFix = (request, node) => {
    // Find the object type the node's properties are being assigned into
    const assignedType = assignments_1.getManuallyAssignedTypeOfNode(request, node);
    if (assignedType === undefined) {
        return undefined;
    }
    const propertyMutations = node.properties
        // Find all properties with a nullable value being passed into a non-nullable type
        .filter((property) => {
        // Ignore any property with a name that's not immediately convertable to a string
        const propertyName = names_1.getStaticNameOfProperty(property.name);
        if (propertyName === undefined) {
            return false;
        }
        // Also ignore any properties not declared in the assigned type
        const assignedProperty = assignedType.getProperty(propertyName);
        if (!assignedProperty) {
            return false;
        }
        // We'll mutate properties that are declared as non-nullable but assigned a nullable value
        const propertyType = types_1.getTypeAtLocationIfNotError(request, property);
        return (propertyType !== undefined &&
            nodeTypes_1.isNullOrUndefinedMissingBetween(propertyType, request.services.program.getTypeChecker().getDeclaredTypeOfSymbol(assignedProperty)));
    })
        // Convert each of those properties into an assertion mutation
        .map((property) => createNonNullAssertion_1.createNonNullAssertion(request, property));
    return propertyMutations.length === 0 ? undefined : automutate_1.combineMutations(...propertyMutations);
};
//# sourceMappingURL=index.js.map