"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.fixStrictNonNullAssertionPropertyAccesses = void 0;
const ts = __importStar(require("typescript"));
const flags_1 = require("../../../../mutations/collecting/flags");
const createNonNullAssertion_1 = require("../../../../mutations/typeMutating/createNonNullAssertion");
const types_1 = require("../../../../shared/types");
const collectMutationsFromNodes_1 = require("../../../collectMutationsFromNodes");
const fixStrictNonNullAssertionPropertyAccesses = (request) => {
    const visitPropertyAccessExpression = (node) => {
        return getStrictPropertyAccessFix(request, node);
    };
    return collectMutationsFromNodes_1.collectMutationsFromNodes(request, ts.isPropertyAccessExpression, visitPropertyAccessExpression);
};
exports.fixStrictNonNullAssertionPropertyAccesses = fixStrictNonNullAssertionPropertyAccesses;
const getStrictPropertyAccessFix = (request, node) => {
    // Early on skip checking for "!" needs if there already is one or it's a ?.
    if (ts.isAssertionExpression(node.parent) || ts.isNonNullExpression(node.parent) || node.questionDotToken) {
        return undefined;
    }
    // Grab the type of the property being accessed by name
    const expressionType = types_1.getTypeAtLocationIfNotError(request, node.expression);
    // If the property's type cannot be null or undefined, rejoice! Nothing to do.
    if (expressionType === undefined || !flags_1.isTypeFlagSetRecursively(expressionType, ts.TypeFlags.Null | ts.TypeFlags.Undefined)) {
        return undefined;
    }
    // Add a mutation to insert a "!" before the access
    return createNonNullAssertion_1.createNonNullAssertion(request, node.expression);
};
//# sourceMappingURL=index.js.map