"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.collectReturningNodeExpressions = void 0;
const tsutils = __importStar(require("tsutils"));
const ts = __importStar(require("typescript"));
/**
 * Finds any nodes returned by a function-like.
 *
 * @param functionLikeDeclaration   Returning function-like declaration.
 * @returns Expression nodes returned from the function-like.
 */
const collectReturningNodeExpressions = (functionLikeDeclaration) => {
    const returnedTypes = [];
    // Search through nodes within the function-like to find all its return statements
    const visitNode = (node) => {
        // Don't look at returns within a nested function-like signature: they return for that function
        if (tsutils.isFunctionWithBody(node)) {
            return;
        }
        // Add new returning nodes as needed when we find any 'return' statement with a value (expression) returned
        if (tsutils.isReturnStatement(node) && node.expression !== undefined) {
            returnedTypes.push(node.expression);
        }
        ts.forEachChild(node, visitNode);
    };
    ts.forEachChild(functionLikeDeclaration, visitNode);
    return returnedTypes;
};
exports.collectReturningNodeExpressions = collectReturningNodeExpressions;
//# sourceMappingURL=collectReturningNodeExpressions.js.map