"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.fixStrictNonNullAssertions = void 0;
const runtime_1 = require("../../../shared/runtime");
const fixStrictNonNullAssertionBinaryExpressions_1 = require("./fixStrictNonNullAssertionBinaryExpressions");
const fixStrictNonNullAssertionCallExpressions_1 = require("./fixStrictNonNullAssertionCallExpressions");
const fixStrictNonNullAssertionObjectLiterals_1 = require("./fixStrictNonNullAssertionObjectLiterals");
const fixStrictNonNullAssertionPropertyAccesses_1 = require("./fixStrictNonNullAssertionPropertyAccesses");
const fixStrictNonNullAssertionReturnTypes_1 = require("./fixStrictNonNullAssertionReturnTypes");
const fixStrictNonNullAssertions = (request) => request.options.fixes.strictNonNullAssertions
    ? runtime_1.findFirstMutations(request, [
        ["fixStrictNonNullAssertionBinaryExpressions", fixStrictNonNullAssertionBinaryExpressions_1.fixStrictNonNullAssertionBinaryExpressions],
        ["fixStrictNonNullAssertionCallExpressions", fixStrictNonNullAssertionCallExpressions_1.fixStrictNonNullAssertionCallExpressions],
        ["fixStrictNonNullAssertionObjectLiterals", fixStrictNonNullAssertionObjectLiterals_1.fixStrictNonNullAssertionObjectLiterals],
        ["fixStrictNonNullAssertionPropertyAccesses", fixStrictNonNullAssertionPropertyAccesses_1.fixStrictNonNullAssertionPropertyAccesses],
        ["fixStrictNonNullAssertionReturnTypes", fixStrictNonNullAssertionReturnTypes_1.fixStrictNonNullAssertionReturnTypes],
    ])
    : undefined;
exports.fixStrictNonNullAssertions = fixStrictNonNullAssertions;
//# sourceMappingURL=index.js.map