"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.collectMutationsFromNodes = void 0;
const os_1 = require("os");
const ts = __importStar(require("typescript"));
const errors_1 = require("../shared/errors");
const collectMutationsFromNodes = (request, selector, visitor) => {
    const mutations = [];
    const visitNode = (node) => {
        if (request.filteredNodes.has(node)) {
            return;
        }
        if (selector(node)) {
            const mutation = tryGetMutation(request, node, visitor);
            if (mutation !== undefined) {
                mutations.push(mutation);
            }
        }
        ts.forEachChild(node, visitNode);
    };
    ts.forEachChild(request.sourceFile, visitNode);
    return mutations;
};
exports.collectMutationsFromNodes = collectMutationsFromNodes;
const tryGetMutation = (request, node, visitor) => {
    try {
        return visitor(node, request);
    }
    catch (error) {
        request.options.output.stderr(`${os_1.EOL}Error in ${request.sourceFile.fileName} at node '${node.getText(request.sourceFile)}' (position ${node.pos}):`);
        request.options.output.stderr(`\t${errors_1.getQuickErrorSummary(error)}`);
        request.options.output.stderr(os_1.EOL);
    }
    return undefined;
};
//# sourceMappingURL=collectMutationsFromNodes.js.map