"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.ReactPropTypesOptionality = exports.ReactPropTypesHint = void 0;
/**
 * Whether to use components' propTypes for inferences.
 */
var ReactPropTypesHint;
(function (ReactPropTypesHint) {
    /**
     * Always factor in all propTypes.
     */
    ReactPropTypesHint["Always"] = "always";
    /**
     * Don't factor in propTypes at all.
     */
    ReactPropTypesHint["Ignore"] = "ignore";
    /**
     * Only factor in nodes that are make as .required.
     */
    ReactPropTypesHint["WhenRequired"] = "whenRequired";
})(ReactPropTypesHint = exports.ReactPropTypesHint || (exports.ReactPropTypesHint = {}));
/**
 * Whether to make propType inferences optional and/or required.
 */
var ReactPropTypesOptionality;
(function (ReactPropTypesOptionality) {
    /**
     * Always make the added props optional.
     */
    ReactPropTypesOptionality["AlwaysOptional"] = "alwaysOptional";
    /**
     * Always make the added props required.
     */
    ReactPropTypesOptionality["AlwaysRequired"] = "alwaysRequired";
    /**
     * Respect whether the original code has .isRequired.
     */
    ReactPropTypesOptionality["AsWritten"] = "asWritten";
})(ReactPropTypesOptionality = exports.ReactPropTypesOptionality || (exports.ReactPropTypesOptionality = {}));
//# sourceMappingURL=enums.js.map