"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.findRawOptions = void 0;
const path = __importStar(require("path"));
/**
 * Parses raw options from a configuration file.
 *
 * @param cwd   Base directory to resolve paths from.
 * @param configPath   Suggested path to load from, instead of searching.
 * @returns Promise for parsed raw options from a configuration file, or an error string.
 */
const findRawOptions = (cwd, configPath) => __awaiter(void 0, void 0, void 0, function* () {
    const resolutionPath = path.join(cwd, configPath);
    let filePath;
    try {
        filePath = require.resolve(resolutionPath);
    }
    catch (_a) {
        return configPath === resolutionPath
            ? `Could not find config file at '${configPath}'.`
            : `Could not find config file at '${configPath}' (resolved to '${resolutionPath}').`;
    }
    const allRawOptions = extractConfigAsRelative(filePath, require(filePath));
    return { filePath, allRawOptions };
});
exports.findRawOptions = findRawOptions;
const extractConfigAsRelative = (filePath, config) => {
    return config instanceof Array ? config.map((config) => relativizeConfig(filePath, config)) : [relativizeConfig(filePath, config)];
};
const relativizeConfig = (filePath, config) => {
    if (config.package !== undefined && config.package.directory !== undefined && !path.isAbsolute(config.package.directory)) {
        config = Object.assign(Object.assign({}, config), { package: Object.assign(Object.assign({}, config.package), { directory: path.join(filePath, config.package.directory) }) });
    }
    return config;
};
//# sourceMappingURL=findRawOptions.js.map