"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.collectStrictNullChecks = void 0;
const collectStrictNullChecks = (compilerOptions, rawOptionTypes) => {
    const typeStrictNullChecks = rawOptionTypes.strictNullChecks;
    const compilerStrictNullChecks = collectCompilerStrictNullChecks(compilerOptions, typeStrictNullChecks);
    return { compilerStrictNullChecks, typeStrictNullChecks };
};
exports.collectStrictNullChecks = collectStrictNullChecks;
const collectCompilerStrictNullChecks = (compilerOptions, typeStrictNullChecks) => {
    if (typeStrictNullChecks !== undefined) {
        return typeStrictNullChecks;
    }
    if (compilerOptions.strictNullChecks !== undefined) {
        return compilerOptions.strictNullChecks;
    }
    if (compilerOptions.strict !== undefined) {
        return compilerOptions.strict;
    }
    return false;
};
//# sourceMappingURL=collectStrictNullChecks.js.map