"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.collectFilteredNodes = void 0;
const tsquery_1 = require("@phenomnomnominal/tsquery");
const collectFilteredNodes = (options, sourceFile) => {
    const filteredNodes = new Set();
    if (options.filters === undefined) {
        return filteredNodes;
    }
    for (const filter of options.filters) {
        for (const node of tsquery_1.tsquery(sourceFile, filter)) {
            filteredNodes.add(node);
        }
    }
    return filteredNodes;
};
exports.collectFilteredNodes = collectFilteredNodes;
//# sourceMappingURL=collectFilteredNodes.js.map