"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.createProviderFromProviders = void 0;
/**
 * Creates a provider that runs through a series of providers.
 *
 * @param providers   Providers to return changes from, in order.
 * @returns Single provider equivalent to the given providers, in order.
 */
const createProviderFromProviders = (...providers) => {
    let index = 0;
    const multiProvider = () => __awaiter(void 0, void 0, void 0, function* () {
        if (index === providers.length) {
            return {
                fileMutations: undefined,
            };
        }
        const results = yield providers[index]();
        if (results.fileMutations === undefined) {
            index += 1;
            return multiProvider();
        }
        return results;
    });
    return multiProvider;
};
exports.createProviderFromProviders = createProviderFromProviders;
//# sourceMappingURL=createProviderFromProviders.js.map