"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.createTypeStatProvider = void 0;
const createProviderFromProviders_1 = require("./createProviderFromProviders");
const createCoreMutationsProvider_1 = require("./providers/createCoreMutationsProvider");
const createInstallMissingTypesProvider_1 = require("./providers/createInstallMissingTypesProvider");
const createMarkFilesModifiedProvider_1 = require("./providers/createMarkFilesModifiedProvider");
const createPostProcessingProvider_1 = require("./providers/createPostProcessingProvider");
const createRequireRenameProvider_1 = require("./providers/createRequireRenameProvider");
/**
 * Creates a mutations provider that mutates files, then marks them as mutated.
 */
const createTypeStatProvider = (options) => {
    const allModifiedFiles = new Set();
    return {
        provide: createProviderFromProviders_1.createProviderFromProviders(createInstallMissingTypesProvider_1.createInstallMissingTypesProvider(options), createRequireRenameProvider_1.createRequireRenameProvider(options, allModifiedFiles), createCoreMutationsProvider_1.createCoreMutationsProvider(options, allModifiedFiles), createMarkFilesModifiedProvider_1.createMarkFilesModifiedProvider(options, allModifiedFiles), createPostProcessingProvider_1.createPostProcessingProvider(options, allModifiedFiles)),
    };
};
exports.createTypeStatProvider = createTypeStatProvider;
//# sourceMappingURL=createTypeStatProvider.js.map