"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.createPostProcessingProvider = void 0;
const createSingleUserProvider_1 = require("../createSingleUserProvider");
const runCommand_1 = require("./missingTypes/runCommand");
/**
 * Creates a mutations wave to run any post-processing shell scripts.
 *
 * @param options   Parsed runtime options for TypeStat.
 * @param allModifiedFilePaths   Unique names of all files that were modified.
 * @returns Mutations wave with no direct mutation changes.
 */
const createPostProcessingProvider = (options, allModifiedFilePaths) => {
    return createSingleUserProvider_1.createSingleUseProvider(() => __awaiter(void 0, void 0, void 0, function* () {
        for (const shellCommand of options.postProcess.shell) {
            yield runCommand_1.runCommand(options, [...shellCommand, ...Array.from(allModifiedFilePaths)]);
        }
        return {};
    }));
};
exports.createPostProcessingProvider = createPostProcessingProvider;
//# sourceMappingURL=createPostProcessingProvider.js.map