"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.LazyCache = void 0;
class LazyCache {
    constructor(getter) {
        this.getter = getter;
    }
    get() {
        if (this.value === undefined) {
            this.value = this.getter();
        }
        return this.value;
    }
    clear() {
        this.value = undefined;
    }
}
exports.LazyCache = LazyCache;
//# sourceMappingURL=LazyCache.js.map