"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.createProgramConfiguration = void 0;
const fs = __importStar(require("mz/fs"));
const path = __importStar(require("path"));
const createExposedTypeScript_1 = require("../mutations/createExposedTypeScript");
const arrays_1 = require("../shared/arrays");
const paths_1 = require("../shared/paths");
const createProgramConfiguration = (options) => {
    const ts = createExposedTypeScript_1.requireExposedTypeScript();
    // Create a TypeScript configuration using the raw options
    const parsedConfiguration = ts.parseJsonConfigFileContent(Object.assign(Object.assign({}, options.compilerOptions), { skipLibCheck: true }), {
        fileExists: fs.existsSync,
        readDirectory: ts.sys.readDirectory,
        readFile: (file) => fs.readFileSync(file, "utf8"),
        useCaseSensitiveFileNames: true,
    }, path.resolve(path.dirname(options.projectPath)), { noEmit: true });
    // Include all possible file names in our program, including ones we won't later visit
    // TypeScript projects must include source files for all nodes we look at
    // See https://github.com/Microsoft/TypeScript/issues/28413
    const fileNames = arrays_1.uniquify(...Array.from(arrays_1.collectOptionals(options.fileNames, parsedConfiguration.fileNames)).map(paths_1.normalizeAndSlashify));
    // Create a basic TypeScript compiler host and program using the parsed compiler options
    const host = ts.createCompilerHost({}, true);
    const program = ts.createProgram(fileNames, options.compilerOptions, host);
    return { fileNames, parsedConfiguration, program };
};
exports.createProgramConfiguration = createProgramConfiguration;
//# sourceMappingURL=createProgramConfiguration.js.map