"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.FileInfoCache = void 0;
const tsutils = __importStar(require("tsutils"));
const references_1 = require("./references");
class FileInfoCache {
    constructor(filteredNodes, services, sourceFile) {
        this.filteredNodes = filteredNodes;
        this.services = services;
        this.sourceFile = sourceFile;
        this.nodeReferences = new Map();
    }
    /**
     * @returns All corresponding nodes for the reference entries for a node.
     */
    getNodeReferencesAsNodes(node) {
        let references = this.nodeReferences.get(node);
        if (references === undefined) {
            references = references_1.findRelevantNodeReferencesAsNodes(this.filteredNodes, this.services, node);
            this.nodeReferences.set(node, references);
        }
        return references;
    }
    getVariableUsage() {
        if (this.variableUsage === undefined) {
            this.variableUsage = tsutils.collectVariableUsage(this.sourceFile);
        }
        return this.variableUsage;
    }
}
exports.FileInfoCache = FileInfoCache;
//# sourceMappingURL=FileInfoCache.js.map