"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.NameGenerator = void 0;
/**
 * Generates new names that are unique per file.
 */
class NameGenerator {
    constructor(sourceFileName) {
        this.sourceFileName = sourceFileName;
        this.countsPerBase = new Map();
    }
    generateName(base) {
        const existingCount = this.countsPerBase.get(base);
        if (existingCount === undefined) {
            this.countsPerBase.set(base, 1);
            return `${this.sourceFileName}${base}`;
        }
        this.countsPerBase.set(base, existingCount + 1);
        return `${this.sourceFileName}${base}${existingCount + 1}`;
    }
}
exports.NameGenerator = NameGenerator;
//# sourceMappingURL=NameGenerator.js.map