"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.uniquify = exports.isNotUndefined = exports.collectOptionals = exports.arrayify = void 0;
const arrayify = (items) => {
    if (items === undefined) {
        return [];
    }
    if (items instanceof Array) {
        return items;
    }
    return [items];
};
exports.arrayify = arrayify;
const collectOptionals = (...arrays) => {
    const results = [];
    for (const array of arrays) {
        if (array !== undefined) {
            results.push(...array);
        }
    }
    return results;
};
exports.collectOptionals = collectOptionals;
const isNotUndefined = (item) => item !== undefined;
exports.isNotUndefined = isNotUndefined;
const uniquify = (...items) => {
    return Array.from(new Set(items));
};
exports.uniquify = uniquify;
//# sourceMappingURL=arrays.js.map