"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.getCallExpressionType = exports.getDeclaredTypesOfArgument = void 0;
const ts = __importStar(require("typescript"));
const types_1 = require("./types");
const getDeclaredTypesOfArgument = (request, parentCall, argument) => {
    const declaredTypes = [];
    if (parentCall.arguments === undefined) {
        return declaredTypes;
    }
    const parentCallType = types_1.getTypeAtLocationIfNotError(request, parentCall.expression);
    if (parentCallType === undefined) {
        return declaredTypes;
    }
    // Get the signatures for that parent call
    const argumentIndex = parentCall.arguments.indexOf(argument);
    const typeChecker = request.services.program.getTypeChecker();
    const parentSignatures = ts.isCallExpression(parentCall) ? parentCallType.getCallSignatures() : parentCallType.getConstructSignatures();
    for (const parentSignature of parentSignatures) {
        if (argumentIndex >= parentSignature.parameters.length || parentSignature.declaration === undefined) {
            continue;
        }
        const parameterSymbol = parentSignature.parameters[argumentIndex];
        const parameterType = typeChecker.getTypeOfSymbolAtLocation(parameterSymbol, parentSignature.declaration.parameters[argumentIndex]);
        declaredTypes.push(parameterType);
    }
    return declaredTypes;
};
exports.getDeclaredTypesOfArgument = getDeclaredTypesOfArgument;
const getCallExpressionType = (request, parentCall) => {
    const typeChecker = request.services.program.getTypeChecker();
    const argumentTypes = parentCall.arguments.map((argument) => typeChecker.getTypeAtLocation(argument));
    return [
        "((",
        argumentTypes.map((parameter, index) => `arg${index}: ${request.services.printers.type(parameter)}`).join(", "),
        ") => unknown)",
    ].join("");
};
exports.getCallExpressionType = getCallExpressionType;
//# sourceMappingURL=calls.js.map