"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.globAllAsync = exports.globAsync = void 0;
const glob_1 = __importDefault(require("glob"));
const globAsync = (include, options = {}) => __awaiter(void 0, void 0, void 0, function* () {
    return new Promise((resolve, reject) => {
        glob_1.default(include, options, (error, matches) => {
            if (error !== null) {
                reject(error);
                return;
            }
            resolve(matches);
        });
    });
});
exports.globAsync = globAsync;
const globAllAsync = (includes, options = {}) => __awaiter(void 0, void 0, void 0, function* () {
    return (yield Promise.all(includes.map((include) => __awaiter(void 0, void 0, void 0, function* () { return exports.globAsync(include, options); })))).reduce((allResults, nextResults) => allResults.concat(nextResults), []);
});
exports.globAllAsync = globAllAsync;
//# sourceMappingURL=glob.js.map