"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.getBaseClassDeclaration = exports.getClassExtendsExpression = void 0;
const ts = __importStar(require("typescript"));
const types_1 = require("./types");
const getClassExtendsExpression = (node) => {
    const { heritageClauses } = node;
    if (heritageClauses === undefined) {
        return undefined;
    }
    const classExtension = heritageClauses.find((clause) => clause.token === ts.SyntaxKind.ExtendsKeyword);
    if (classExtension === undefined) {
        return undefined;
    }
    return classExtension.types.length === 1 ? classExtension.types[0] : undefined;
};
exports.getClassExtendsExpression = getClassExtendsExpression;
const getBaseClassDeclaration = (request, extension) => {
    var _a;
    // First try retrieving the base class from the extension itself
    let extensionSymbol = (_a = types_1.getTypeAtLocationIfNotError(request, extension)) === null || _a === void 0 ? void 0 : _a.getSymbol();
    // If that didn't work, it might be from a type error due to missing type parameters
    // Try the base constructor of the child class instead
    // This is an internal member, but ah well...
    if (extensionSymbol === undefined) {
        const { resolvedBaseConstructorType } = types_1.getTypeAtLocationIfNotError(request, extension.parent.parent);
        if (resolvedBaseConstructorType !== undefined) {
            extensionSymbol = resolvedBaseConstructorType.symbol;
        }
    }
    if (extensionSymbol === undefined) {
        return undefined;
    }
    const { valueDeclaration } = extensionSymbol;
    if (!valueDeclaration || !ts.isClassLike(valueDeclaration)) {
        return undefined;
    }
    return valueDeclaration;
};
exports.getBaseClassDeclaration = getBaseClassDeclaration;
//# sourceMappingURL=nodeExtensions.js.map