"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.printNamedTypeSummary = exports.printNamedTypeSummaries = void 0;
const newlines_1 = require("./newlines");
const printNamedTypeSummaries = (request, enclosingDeclaration, typeSummaries) => {
    return Array.from(typeSummaries)
        .map(([typeName, typeSummary]) => exports.printNamedTypeSummary(request, enclosingDeclaration, typeName, typeSummary))
        .join("");
};
exports.printNamedTypeSummaries = printNamedTypeSummaries;
const printNamedTypeSummary = (request, enclosingDeclaration, name, summary) => {
    return [
        name,
        summary.alwaysProvided ? "?: " : ": ",
        request.services.printers.type(summary.types, enclosingDeclaration),
        ";",
        newlines_1.printNewLine(request.options.compilerOptions),
    ].join("");
};
exports.printNamedTypeSummary = printNamedTypeSummary;
//# sourceMappingURL=nodePrinting.js.map