"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.findFirstMutations = void 0;
const complaint_1 = require("../mutators/complaint");
const findFirstMutations = (request, mutators) => {
    for (const [mutatorName, mutator] of mutators) {
        try {
            const result = mutator(request);
            if (result instanceof complaint_1.MutationsComplaint) {
                logOutput(request, mutatorName, "found a complaint", result);
                return complaint_1.MutationsComplaint.wrapping(mutatorName, result);
            }
            if (result !== undefined && result.length !== 0) {
                logOutput(request, mutatorName, "found mutations", result);
                return result;
            }
        }
        catch (error) {
            logOutput(request, mutatorName, "threw an error", error);
            return new complaint_1.MutationsComplaint(error, [mutatorName]);
        }
    }
    return undefined;
};
exports.findFirstMutations = findFirstMutations;
const logOutput = (request, mutatorName, action, data) => {
    request.options.output.log([mutatorName, ` ${action} in `, request.sourceFile.fileName, ": ", JSON.stringify(data, null, 4)].join(""));
};
//# sourceMappingURL=runtime.js.map