"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var _a;
Object.defineProperty(exports, "__esModule", { value: true });
const automutate_tests_1 = require("automutate-tests");
const commander_1 = require("commander");
const fs = __importStar(require("fs"));
const path = __importStar(require("path"));
const createExposedTypeScript_1 = require("../mutations/createExposedTypeScript");
const fillOutRawOptions_1 = require("../options/fillOutRawOptions");
const createTypeStatProvider_1 = require("../runtime/createTypeStatProvider");
const arrays_1 = require("../shared/arrays");
const parsed = new commander_1.Command()
    // Allow unknown options for the case of IDE debuggers who directly write to process.argv
    // If this line is removed, VS Code debugging will break 😲
    .allowUnknownOption(true)
    .option("-i, --include [include]", "path to a TypeScript project file")
    .option("-a, --accept", "override existing expected results instead of asserting")
    .parse(process.argv)
    .opts();
// Modify TypeScript here so that no tests incur the performance penalty of doing it themselves
const ts = createExposedTypeScript_1.requireExposedTypeScript();
const rawPathToRegExp = (rawPath) => new RegExp(`.*${rawPath.split(/\\|\//g).slice(-3).join(".*")}.*`, "i");
// The .vscode/launch.json task adds includes via environment variable
const includes = [...arrays_1.arrayify((_a = parsed.include) !== null && _a !== void 0 ? _a : []).map(rawPathToRegExp), ...arrays_1.arrayify(process.env.TEST_GLOB).map(rawPathToRegExp)];
automutate_tests_1.describeMutationTestCases(path.join(__dirname, "../../test"), (fileName, typeStatPath) => {
    if (typeStatPath === undefined) {
        throw new Error(`Could not find typestat.json for ${fileName}.`);
    }
    const projectDirectory = path.dirname(typeStatPath);
    const rawOptions = JSON.parse(fs.readFileSync(typeStatPath).toString());
    const projectPath = path.join(projectDirectory, "tsconfig.json");
    const rawCompilerOptions = fs.readFileSync(typeStatPath).toString();
    const compilerOptions = ts.parseConfigFileTextToJson(typeStatPath, rawCompilerOptions).config;
    const output = {
        log: () => { },
        stderr: console.error.bind(console),
        stdout: () => { },
    };
    return createTypeStatProvider_1.createTypeStatProvider(Object.assign(Object.assign({}, fillOutRawOptions_1.fillOutRawOptions({
        argv: { args: [] },
        compilerOptions,
        cwd: path.dirname(projectPath),
        output,
        projectPath,
        rawOptions: Object.assign(Object.assign({}, rawOptions), { projectPath }),
    })), { fileNames: [fileName] }));
}, {
    accept: parsed.accept || !!process.env.TEST_ACCEPT,
    actual: (original) => (original.endsWith("x") ? "actual.tsx" : "actual.ts"),
    expected: (original) => (original.endsWith("x") ? "expected.tsx" : "expected.ts"),
    includes,
    normalizeEndlines: "\n",
    original: "./original.*",
    settings: "typestat.json",
    // *Two* waves allow testing that regular mutations happens alongside pre or post processing.
    waves: { maximum: 2 },
});
//# sourceMappingURL=runTests.js.map